namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IMapping
{ // ...

    static string GetDeterministicHashCodeKey(int id, int normalizedPixelPercentage)
        => $"{id}.{normalizedPixelPercentage}";

    (int?, int?, List<Models.Face>?) TestStatic_GetReversedDeterministicHashCodeKey(int locationDigits, string file) =>
        GetReversedDeterministicHashCodeKey(locationDigits, file);
    static (int?, int?, List<Models.Face>?) GetReversedDeterministicHashCodeKey(int locationDigits, string file) =>
        Mapping.GetReversedDeterministicHashCodeKey(locationDigits, false, new(), file);

    (int?, int?, List<Models.Face>?) TestStatic_GetReversedDeterministicHashCodeKey(int locationDigits, bool keyValuePairsAny, Dictionary<int, List<Models.Face>> keyValuePairs, string file) =>
        GetReversedDeterministicHashCodeKey(locationDigits, keyValuePairsAny, keyValuePairs, file);
    static (int?, int?, List<Models.Face>?) GetReversedDeterministicHashCodeKey(int locationDigits, bool keyValuePairsAny, Dictionary<int, List<Models.Face>> keyValuePairs, string file) =>
        Mapping.GetReversedDeterministicHashCodeKey(locationDigits, keyValuePairsAny, keyValuePairs, file);

}